#include <windows.h>

#if defined(__cplusplus)
extern "C" {
#endif



HMODULE m_library = 0;

typedef int (*_RegisterWSQ)();
_RegisterWSQ RegisterWSQ = 0;

typedef char* (*_GenerateWSQLibrarySerialNumber)();
_GenerateWSQLibrarySerialNumber GenerateWSQLibrarySerialNumber = 0;

typedef int (*_UnlockWSQLibrary)(const char* authorizationcode);
_UnlockWSQLibrary UnlockWSQLibrary = 0;

typedef void (*_ShowFileConverter)();
_ShowFileConverter ShowFileConverter = 0;

typedef HBITMAP (*_CreateBMPFromFile)(const char*);
_CreateBMPFromFile CreateBMPFromFile = 0;

typedef int (*_SaveBMPToFile)(HBITMAP, const char*, int);
_SaveBMPToFile SaveBMPToFile = 0;

typedef void (*_WriteWSQ_bitrate)(double);
_WriteWSQ_bitrate WriteWSQ_bitrate = 0;

typedef double (*_ReadWSQ_bitrate)();
_ReadWSQ_bitrate ReadWSQ_bitrate = 0;

typedef void (*_WriteWSQ_ppi)(int);
_WriteWSQ_ppi WriteWSQ_ppi = 0;

typedef int (*_ReadWSQ_ppi)();
_ReadWSQ_ppi ReadWSQ_ppi = 0;

typedef void (*_WriteWSQ_comment)(char*);
_WriteWSQ_comment WriteWSQ_comment = 0;

typedef char* (*_ReadWSQ_comment)();
_ReadWSQ_comment ReadWSQ_comment = 0;

typedef void (*_WriteTIFFcompression)(int);
_WriteTIFFcompression WriteTIFFcompression = 0;

typedef void (*_WriteTIFFpredictor)(int);
_WriteTIFFpredictor WriteTIFFpredicator = 0;

typedef void (*_SetShowFilePropertiesDialog)(int);
_SetShowFilePropertiesDialog SetShowFilePropertiesDialog = 0;

typedef HBITMAP (*_ConvertHBITMAPtoGrayScale256)(HBITMAP hBitmap);
_ConvertHBITMAPtoGrayScale256 ConvertHBITMAPtoGrayScale256 = 0;

typedef int (*_SaveHBITMAPtoFileAsGrayScale256BMP)(HBITMAP hBitmap, const char *filename);
_SaveHBITMAPtoFileAsGrayScale256BMP SaveHBITMAPtoFileAsGrayScale256BMP = 0;




__declspec( dllexport ) int __stdcall RegisterWSQ_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!RegisterWSQ) {
		RegisterWSQ = (_RegisterWSQ)::GetProcAddress(m_library, "_RegisterWSQ");
	}
	if (!RegisterWSQ) {
		MessageBoxA(0, "Unable to get RegisterWSQ function address", "Error", 0);
		return 0;
	}

	return RegisterWSQ();
}


__declspec( dllexport ) char* __stdcall GenerateWSQLibrarySerialNumber_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!GenerateWSQLibrarySerialNumber) {
		GenerateWSQLibrarySerialNumber = (_GenerateWSQLibrarySerialNumber)::GetProcAddress(m_library, "_GenerateWSQLibrarySerialNumber");
	}
	if (!GenerateWSQLibrarySerialNumber) {
		MessageBoxA(0, "Unable to get GenerateWSQLibrarySerialNumber function address", "Error", 0);
		return 0;
	}

	return GenerateWSQLibrarySerialNumber();
}


__declspec( dllexport ) int __stdcall UnlockWSQLibrary_stdcall(const char* authorizationcode)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!UnlockWSQLibrary) {
		UnlockWSQLibrary = (_UnlockWSQLibrary)::GetProcAddress(m_library, "_UnlockWSQLibrary");
	}
	if (!UnlockWSQLibrary) {
		MessageBoxA(0, "Unable to get UnlockWSQLibrary function address", "Error", 0);
		return 0;
	}

	return UnlockWSQLibrary(authorizationcode);




}



__declspec( dllexport ) HBITMAP __stdcall CreateBMPFromFile_stdcall( const char *filename)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!CreateBMPFromFile) {
		CreateBMPFromFile = (_CreateBMPFromFile)::GetProcAddress(m_library, "_CreateBMPFromFile");
	}
	if (!CreateBMPFromFile) {
		MessageBoxA(0, "Unable to get CreateBMPFromFile function address", "Error", 0);
		return 0;
	}

HBITMAP hBitmap;
		hBitmap = CreateBMPFromFile(filename);
	if (!hBitmap) {
		MessageBoxA(0, "Unable to get HBITMAP", "Error", 0);
		return 0;
	}
	return hBitmap;

}

__declspec( dllexport ) int __stdcall SaveBMPToFile_stdcall( HBITMAP hBitmap,      /* bitmap to be saved */
                                 const char *filename, int filetype) /* name of output file */
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!SaveBMPToFile) {
		SaveBMPToFile = (_SaveBMPToFile)::GetProcAddress(m_library, "_SaveBMPToFile");
	}
	if (!SaveBMPToFile) {
		MessageBoxA(0, "Unable to get SaveBMPToFile function address", "Error", 0);
		return 0;
	}

	return SaveBMPToFile(hBitmap, filename, filetype);

}

__declspec( dllexport ) void __stdcall WriteWSQ_bitrate_stdcall(double bitrate)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!WriteWSQ_bitrate) {
		WriteWSQ_bitrate = (_WriteWSQ_bitrate)::GetProcAddress(m_library, "_WriteWSQ_bitrate");
	}
	if (!WriteWSQ_bitrate) {
		MessageBoxA(0, "Unable to get WriteWSQ_bitrate function address", "Error", 0);
		return;
	}

	WriteWSQ_bitrate(bitrate);
}

__declspec( dllexport ) double __stdcall ReadWSQ_bitrate_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!ReadWSQ_bitrate) {
		ReadWSQ_bitrate = (_ReadWSQ_bitrate)::GetProcAddress(m_library, "_ReadWSQ_bitrate");
	}
	if (!ReadWSQ_bitrate) {
		MessageBoxA(0, "Unable to get ReadWSQ_bitrate function address", "Error", 0);
		return 0;
	}

	return ReadWSQ_bitrate();

}

__declspec( dllexport ) void __stdcall WriteWSQ_ppi_stdcall(int ppi)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!WriteWSQ_ppi) {
		WriteWSQ_ppi = (_WriteWSQ_ppi)::GetProcAddress(m_library, "_WriteWSQ_ppi");
	}
	if (!WriteWSQ_ppi) {
		MessageBoxA(0, "Unable to get WriteWSQ_ppi function address", "Error", 0);
		return;
	}
	WriteWSQ_ppi(ppi);
}

__declspec( dllexport ) int __stdcall ReadWSQ_ppi_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!ReadWSQ_ppi) {
		ReadWSQ_ppi = (_ReadWSQ_ppi)::GetProcAddress(m_library, "_ReadWSQ_ppi");
	}
	if (!ReadWSQ_ppi) {
		MessageBoxA(0, "Unable to get ReadWSQ_ppi function address", "Error", 0);
		return 0;
	}
	return ReadWSQ_ppi();
}

__declspec( dllexport ) void __stdcall WriteWSQ_comment_stdcall(char *comment)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!WriteWSQ_comment) {
		WriteWSQ_comment = (_WriteWSQ_comment)::GetProcAddress(m_library, "_WriteWSQ_comment");
	}
	if (!WriteWSQ_comment) {
		MessageBoxA(0, "Unable to get WriteWSQ_comment function address", "Error", 0);
		return;
	}

	WriteWSQ_comment(comment);
}

__declspec( dllexport ) char* __stdcall ReadWSQ_comment_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return "";
	}

	if (!ReadWSQ_comment) {
		ReadWSQ_comment = (_ReadWSQ_comment)::GetProcAddress(m_library, "_ReadWSQ_comment");
	}
	if (!ReadWSQ_comment) {
		MessageBoxA(0, "Unable to get ReadWSQ_comment function address", "Error", 0);
		return "";
	}
	return ReadWSQ_comment();

}

__declspec( dllexport ) void __stdcall WriteTIFFcompression_stdcall(int tiff_compression)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!WriteTIFFcompression) {
		WriteTIFFcompression = (_WriteTIFFcompression)::GetProcAddress(m_library, "_WriteTIFFcompression");
	}
	if (!WriteTIFFcompression) {
		MessageBoxA(0, "Unable to get WriteTIFFcompression function address", "Error", 0);
		return;
	}

	WriteTIFFcompression(tiff_compression);
}

__declspec( dllexport ) void __stdcall WriteTIFFpredictor_stdcall(int tiff_predictor)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!WriteTIFFpredicator) {
		WriteTIFFpredicator = (_WriteTIFFpredictor)::GetProcAddress(m_library, "_WriteTIFFpredictor");
	}
	if (!WriteTIFFpredicator) {
		MessageBoxA(0, "Unable to get WriteTIFFpredicator function address", "Error", 0);
		return;
	}

	WriteTIFFpredicator(tiff_predictor);
}

__declspec( dllexport ) void __stdcall SetShowFilePropertiesDialog_stdcall(int file_properties_dialog)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!SetShowFilePropertiesDialog) {
		SetShowFilePropertiesDialog = (_SetShowFilePropertiesDialog)::GetProcAddress(m_library, "_SetShowFilePropertiesDialog");
	}
	if (!SetShowFilePropertiesDialog) {
		MessageBoxA(0, "Unable to get SetShowFilePropertiesDialog function address", "Error", 0);
		return;
	}

	SetShowFilePropertiesDialog(file_properties_dialog);
}


__declspec( dllexport ) void __stdcall ShowFileConverter_stdcall()
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	if (!ShowFileConverter) {
		ShowFileConverter = (_ShowFileConverter)::GetProcAddress(m_library, "_ShowFileConverter");
	}
	if (!ShowFileConverter) {
		MessageBoxA(0, "Unable to get ShowFileConverter function address", "Error", 0);
		return;
	}

	ShowFileConverter();
}


__declspec( dllexport ) HBITMAP __stdcall ConvertHBITMAPtoGrayScale256_stdcall( HBITMAP hBitmap)
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!ConvertHBITMAPtoGrayScale256) {
		ConvertHBITMAPtoGrayScale256 = (_ConvertHBITMAPtoGrayScale256)::GetProcAddress(m_library, "_ConvertHBITMAPtoGrayScale256");
	}
	if (!ConvertHBITMAPtoGrayScale256) {
		MessageBoxA(0, "Unable to get ConvertHBITMAPtoGrayScale256 function address", "Error", 0);
		return 0;
	}

HBITMAP hBitmap_output;
		hBitmap_output = ConvertHBITMAPtoGrayScale256(hBitmap);
	if (!hBitmap_output) {
		MessageBoxA(0, "Unable to get HBITMAP", "Error", 0);
		return 0;
	}
	return hBitmap_output;

}

__declspec( dllexport ) int __stdcall SaveHBITMAPtoFileAsGrayScale256BMP_stdcall( HBITMAP hBitmap,      /* bitmap to be saved */
                                 const char *filename) /* name of output file */
{
	if (!m_library) {
		m_library = ::LoadLibraryW(L"WSQ_library");
	}
	if (!m_library) {
		MessageBoxA(0, "Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	if (!SaveHBITMAPtoFileAsGrayScale256BMP) {
		SaveHBITMAPtoFileAsGrayScale256BMP = (_SaveHBITMAPtoFileAsGrayScale256BMP)::GetProcAddress(m_library, "_SaveHBITMAPtoFileAsGrayScale256BMP");
	}
	if (!SaveHBITMAPtoFileAsGrayScale256BMP) {
		MessageBoxA(0, "Unable to get SaveHBITMAPtoFileAsGrayScale256BMP function address", "Error", 0);
		return 0;
	}

	return SaveHBITMAPtoFileAsGrayScale256BMP(hBitmap, filename);

}



#if defined(__cplusplus)
 }
#endif


